#include <iostream>
#include <cmath>

using namespace std;



bool find (int x, int a[], int size)
{
	int left=0, right = size-1;

	while (left < right && a[(left+right)/2] != x)
	{
		if (a[(left+right)/2] < x)
			left = (left+right)/2 + 1;
		else
			right = (left+right)/2;
	}

	return a[(left+right)/2] == x;

}

bool findrec (int x, int a[], int size)
{

	if (size == 0)
	{
		return false;
	}
	if (size == 1)
	{
		return a[0] == x;
	}
	if (a[size/2] > x)
	{
		return findrec (x,a,size/2);
	}
	if (a[size/2] < x)
	{
		return findrec (x,a+(int)ceil(size/2.0),ceil(size/2.0)-1);
	}
	return true;
}

bool findreclogic (int x, int a[], int size)
{
	return (size == 1 && a[0] == x) ||
		   (size > 1 && a[size/2] > x && findreclogic (x,a,size/2)) ||
		   (size > 1 && a[size/2] < x && findreclogic (x,a+(int)ceil(size/2.0),ceil(size/2.0)-1)) ||
		   (size > 1 && a[size/2] == x);
}


int main ()
{



	int arr[]={1,3,5,7,9};

	cout << "1:" << find (1,arr,2) << endl;
	cout << "1:" << find (3,arr,2) << endl;
	cout << "0:" << find (2,arr,2) << endl;
	cout << "0:" << find (5,arr,2) << endl;


	cout << "1:" << find (1,arr,3) << endl;
	cout << "1:" << find (3,arr,3) << endl;
	cout << "0:" << find (2,arr,3) << endl;
	cout << "1:" << find (5,arr,3) << endl;

}